import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:stateful_provider/model/dart_error.dart';
import 'package:stateful_provider/provider/process_status_provider.dart';

class ProcessStatusWidget extends StatelessWidget {
  Future Function(DartError error, List<DartError> errors) consumeError;
  final Widget process;

  ProcessStatusWidget({
    required this.consumeError,
    this.process = const CircularProgressIndicator(),
  });

  @override
  Widget build(BuildContext context) => Consumer<ProcessStatusProvider>(
        builder: (_, provider, __) {
          if (provider.hasError) {
            final current = provider.currentError();
            WidgetsBinding.instance?.addPostFrameCallback((timeStamp) async {
              await consumeError(current, provider.errors);
              provider.consumeError(current);
            });
          }
          return provider.isProcessing ? process : Container();
        },
      );
}
